* This file takes services trade classified by BOPS and maps it to
* GTAP model sectors.  Note that sector "SER" is all services net of
* Transport and Travel services.  Note also that TSP is a composite
* of the multiple GTAP transport modes.

clear
set more off
set matsize 750
set mem 1700m
log using TSDv4GTAP.smcl, replace

use TSDv4MIRROR.dta,
keep if sector == 268 | sector == 269 | sector == 262  
replace sm=-sm if sector == 269
replace sx=-sx if sector == 269
replace sector=268 
collapse (sum) sm (sum) sx, by(partner reporter year sector)
sort partner reporter year sector
save tmp1.dta, replace

use TSDv4MIRROR.dta,
keep if sector == 200 | sector == 205  | sector == 236
replace sm=0 if sm==. & sector==236
replace sx=0 if sx==. & sector==236
replace sm=-sm if sector == 205
replace sx=-sx if sector == 205
replace sm=-sm if sector == 236
replace sx=-sx if sector == 236
replace sector = 981
sort partner reporter year sector
collapse (sum) sm (sum) sx, by(partner reporter year sector)
replace sm=0 if sm<0
save tmp2.dta, replace

use TSDv4MIRROR.dta 
sort partner reporter year sector
merge partner reporter year sector using tmp1.dta, update
drop _merge
sort partner reporter year sector
merge partner reporter year sector using tmp2.dta, update
drop _merge

generate GTAP = "XXX"
replace GTAP="TSP" if sector == 205
replace GTAP="COM" if sector == 245
replace GTAP="CNS" if sector == 249
replace GTAP="INS" if sector == 253
replace GTAP="FIN" if sector == 260
replace GTAP="TRD" if sector == 269
replace GTAP="BUS" if sector == 268
replace GTAP="ROS" if sector == 287
replace GTAP="PUB" if sector == 291
replace GTAP="SER" if sector == 981
drop if GTAP=="XXX"
drop sector

save TSDv4GTAP.dta, replace
erase tmp1.dta
erase tmp2.dta

log close

