* This do file takes the primary TSD data set and
* uses reported exports to replace missing imports
* for third countries outside the original reporting
* country set.  The result is a data set of imports for
* reporting countries and mirrored non-reporting countries. 

* The mirror construction is only for BOPS cross border trade.
* One could also mirror FDI flows.

clear
set more off
set matsize 750
set mem 1700m
log using mirrorv4.smcl, replace
use TSDv4.dta 
rename country_code reporter
rename partner_code partner
rename sector_code sector
generate float sm1=sm
generate float sx1=sx
sort reporter partner year sector
save mirror.dta, replace
rename reporter par
rename partner reporter
rename par partner
rename sm1 sx2
rename sx1 sm2
drop sm sx
sort reporter partner year sector
merge reporter partner year sector using mirror.dta, unique sort update
generate str source = "REPORTER"
replace source ="MIRROR" if sm1== .
replace sm1 = sm2 if sm1== .
replace sx1 = sx2 if sx1== .
replace source ="NONE" if sm1== .
generate str BASIS = sm_datasource
replace BASIS ="MIRROR" if source=="MIRROR"
replace sm = sm1 if sm1>0 & (sm==. | sm == 0 ), nopromote
replace sx = sx1 if sx1>0 & (sx==. | sx == 0 ), nopromote
keep reporter partner year sector sm sx fdi_inw fdi_outw fdi_inflow fdi_outflow BASIS
save TSDv4MIRROR.dta, replace
erase mirror.dta
log close

